/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.storage.swap;

import java.io.File;
import java.io.IOException;

import org.exoplatform.services.jcr.config.BinarySwapEntry;
import org.exoplatform.services.jcr.config.WorkspaceEntry;
import org.exoplatform.services.jcr.util.StringNumberParser;
import org.exoplatform.services.jcr.util.UUIDGenerator;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: BinaryValueSwapStorage.java 8632 2006-09-06 14:06:45Z peterit $
 */

public class BinaryValueSwapStorage {
  
  private File rootDir = null; 
  private int minFileSize = -1;

  public BinaryValueSwapStorage(WorkspaceEntry wsConfig) throws IOException {
    BinarySwapEntry bsConfig = wsConfig.getBinarySwap();
    if(bsConfig != null) {
      rootDir = new File(bsConfig.getDirectoryPath());
      if(rootDir.exists())
        // TODO [PN] delete will doesn't work if some files exists inside the dir
        rootDir.delete();
      rootDir.mkdir();
      minFileSize = StringNumberParser.parseNumber(bsConfig.getMinFileSize()).intValue();
    }
  }
  
  public String generatePath() {
    return rootDir.getAbsoluteFile() + File.separator + UUIDGenerator.generate();
  }
  
//  public PersistedValueData createPersistedValueData(LazyInputStream stream, int orderNumber) throws IOException {
//    return new PersistedValueData(stream, orderNumber, generatePath(), minFileSize);
//  }

  public int getMinFileSize() {
    return minFileSize;
  }
  
}
