/***************************************************************************
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.jcr.storage.value;

import java.io.IOException;

import org.exoplatform.services.jcr.datamodel.PropertyData;
import org.exoplatform.services.jcr.storage.swap.BinaryValueSwapStorage;

/**
 * Created by The eXo Platform SARL
 *
 * 04.09.2006
 *
 * @author <a href="mailto:peter.nedonosko@exoplatform.com.ua">Peter Nedonosko</a>
 * @version $Id: ValueStoragePluginProvider.java 8549 2006-09-04 14:23:46Z peterit $
 */
public interface ValueStoragePluginProvider {

  /**
   * @param property
   * @return ValueIOChannel appropriate for this property (by path, id etc)
   * or null if no such channel found 
   * @throws IOException
   */
  ValueIOChannel getApplicableChannel(PropertyData property) throws IOException;
  
  /**
   * @return BinaryValueSwapStorage for particular workspace or null if no such storage was configured
   */
  BinaryValueSwapStorage getBinaryValueSwap();
  
}
