/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core.itemvisitors;

import javax.jcr.RepositoryException;

import org.exoplatform.services.jcr.dataflow.ItemState;
import org.exoplatform.services.jcr.datamodel.IllegalPathException;
import org.exoplatform.services.jcr.datamodel.InternalQName;
import org.exoplatform.services.jcr.datamodel.ItemData;
import org.exoplatform.services.jcr.datamodel.NodeData;
import org.exoplatform.services.jcr.datamodel.PropertyData;
import org.exoplatform.services.jcr.impl.core.SessionDataManager;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeManagerImpl;
/**
 * Created by The eXo Platform SARL        .<br/>
 * Copy Session Items to new place, used by Session.move()
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: $
 */

public class SessionMoveVisitor extends SessionCopyVisitor {


  /**
   * @param dataManager
   * @param parentNode source node data
   * @param rootName destination node name
   */
  public SessionMoveVisitor(SessionDataManager dataManager, NodeData destParentNode, InternalQName destNodeName,
      boolean keepUUIDs, NodeTypeManagerImpl nodeTypeManager) {
    super(dataManager, destParentNode, destNodeName, keepUUIDs, nodeTypeManager);
  }

  @Override
  protected void entering(PropertyData property, int level)
      throws RepositoryException {
    super.entering(property, level);
  }

  @Override
  protected void entering(NodeData node, int level) throws RepositoryException {
    super.entering(node, level);
    if(level == 0)
      dataManager.delete(deletedItemState(node));
  }

  @Override
  protected void leaving(PropertyData property, int level)
      throws RepositoryException {
    super.leaving(property, level);
  }

  @Override
  protected void leaving(NodeData node, int level) throws RepositoryException {
    super.leaving(node, level);
  }
  
  
  private final ItemState deletedItemState(ItemData data) throws IllegalPathException {
    return new ItemState(data, ItemState.DELETED, true, ancestorToSave); 
  }
  
}
