/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.storage.value.fs;

import java.io.File;
import java.io.IOException;
import java.util.Properties;

import org.apache.commons.logging.Log;
import org.exoplatform.services.jcr.storage.value.ValueIOChannel;
import org.exoplatform.services.jcr.storage.value.ValueStoragePlugin;
import org.exoplatform.services.log.ExoLogger;
/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: SimpleFileValueStorage.java 8595 2006-09-05 14:42:58Z peterit $
 */
  
public class SimpleFileValueStorage extends ValueStoragePlugin {
  protected static Log log = ExoLogger.getLogger("jcr.SimpleFileValueStorage");

  public final static String PATH = "path";

  private File rootDir;
  
  public SimpleFileValueStorage() {
  }
  
  public void init(Properties props) throws IOException {
    prepareRootDir(props.getProperty(PATH));
  }
  
  protected void prepareRootDir(String rootDirPath) throws IOException {
    this.rootDir = new File(rootDirPath);
    if(!rootDir.exists()) {
      rootDir.mkdir();
      log.info("Directory created: "+rootDir.getAbsolutePath());
    } else {
      if(!rootDir.isDirectory())
        throw new IOException("File exists but is not a directory "+rootDirPath);
    }
  }

  public ValueIOChannel openIOChannel() throws IOException {
    return new FileIOChannel(rootDir);
  }
  
//  public void initBinarySwap(BinarySwap binarySwap) {
//    if (log.isDebugEnabled())
//      log.debug("Binary swap is not supported by this value storage " + this.getClass().getCanonicalName());
//  }
//  
//  public boolean isBinarySwapEnabled() {
//    if (log.isDebugEnabled())
//      log.debug("Binary swap is not supported by this value storage " + this.getClass().getCanonicalName());
//    return false;
//  }
//  
//  public void enableBinarySwap() {
//    if (log.isDebugEnabled())
//      log.debug("Binary swap is not supported by this value storage " + this.getClass().getCanonicalName());
//  }
//  
//  public void disableBinarySwap() {
//    if (log.isDebugEnabled())
//      log.debug("Binary swap is not supported by this value storage " + this.getClass().getCanonicalName());
//  }
//
}
