/***************************************************************************
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.jcr.impl.storage.value.jdbc;

import java.io.IOException;
import java.sql.SQLException;
import java.util.Properties;

import javax.sql.DataSource;

import org.apache.commons.logging.Log;
import org.exoplatform.services.jcr.config.RepositoryConfigurationException;
import org.exoplatform.services.jcr.storage.value.ValueIOChannel;
import org.exoplatform.services.jcr.storage.value.ValueStoragePlugin;
import org.exoplatform.services.log.ExoLogger;

/**
 * Created by The eXo Platform SARL
 * Author : Peter Nedonosko
 *          peter.nedonosko@exoplatform.com.ua
 * 29.08.2006
 * @version $Id: JDBCValueStorage.java 8552 2006-09-04 14:38:11Z peterit $
 */
public class JDBCValueStorage extends ValueStoragePlugin {

  protected static Log log = ExoLogger.getLogger("jcr.JDBCValueStorage");
  
  private DataSource dataSource = null;
  private boolean multiDB = false;
  private String containerName = null;
  
  public JDBCValueStorage(String containerName, boolean multiDB, DataSource dataSource) {
    this.containerName = containerName;
    this.multiDB = multiDB;
    this.dataSource = dataSource;
  }
  
  public void init(Properties props) throws RepositoryConfigurationException, IOException {
    // empty impl
    
//    try {
//      multiDB = Boolean.parseBoolean(props.getProperty(JDBCWorkspaceDataContainer.MULTIDB));
//    } catch(Throwable e) {
//      if (log.isDebugEnabled())
//        log.debug("Multi-db flag is not set properly. Will be used single-db model. " + e, e);
//    }
//
//    try {
//      containerName = props.getProperty(JDBCWorkspaceDataContainer.CONTAINER_NAME);
//    } catch(Throwable e) {
//      if (log.isDebugEnabled())
//        log.debug("Error of container name read. " + e, e);
//    }
//    
//    Context context = new InitialContext();
//    dataSource = (DataSource) context.lookup(props.getProperty(JDBCWorkspaceDataContainer.SOURCE_NAME));
  }

  public ValueIOChannel openIOChannel() throws IOException {
    try {
      if (isBinarySwapEnabled())
        return new JDBCIOChannel(dataSource, containerName, multiDB, swapStorage);
      return new JDBCIOChannel(dataSource, containerName, multiDB);
    } catch(SQLException e) {
      log.error("Database error in JDBC values storage: " + e.getMessage(), e);
      throw new IOException("Database error: " + e.getMessage());
    }
  }  
}
