/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.core;

import javax.jcr.NamespaceRegistry;
import javax.jcr.Repository;
import javax.jcr.RepositoryException;
import javax.jcr.Session;

import org.exoplatform.services.jcr.core.nodetype.ExtendedNodeTypeManager;
import org.exoplatform.services.jcr.config.RepositoryEntry;

/**
 * Created by The eXo Platform SARL        .<br/>
 * Etended Repository implementation
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: ManageableRepository.java 6678 2006-07-03 11:10:18Z geaz $
 */

public interface ManageableRepository extends Repository {

    /**
     * Initializes workspace
     * @param workspaceName
     * @param rootNodeType
     * @throws RepositoryException
     */
    void initWorkspace(String workspaceName, String rootNodeType) throws RepositoryException;

    /**
     * @param workspaceName
     * @return true if workspace is initialized and false otherwice
     * @throws RepositoryException
     */
    boolean isWorkspaceInitialized(String workspaceName) throws RepositoryException;

    /**
     * @param workspaceName
     * @return the System session (session with SYSTEM identity)
     * @throws RepositoryException
     */
    Session getSystemSession(String workspaceName) throws RepositoryException;
    
    /**
     * @return array of workspace names
     */
    String[] getWorkspaceNames();
    
    /**
     * @return the node type manager
     */
    ExtendedNodeTypeManager getNodeTypeManager();
    
    /**
     * @return the namespace registry
     */
    NamespaceRegistry getNamespaceRegistry();

    /**
     * @return the configuration of this repository
     */
    RepositoryEntry getConfiguration();  
}
