/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.dataflow.persistent;

import java.io.IOException;
import java.io.InputStream;

import org.exoplatform.services.jcr.datamodel.AbstractValueData;
import org.exoplatform.services.jcr.storage.swap.BinaryValueSwapStorage;
import org.exoplatform.services.jcr.util.io.CloneableInputStream;
import org.exoplatform.services.jcr.util.io.LazyInputStream;
/**
 * Created by The eXo Platform SARL        .</br>
 * 
 * Immutable PropertyData
 * 
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: PersistedValueData.java 9852 2006-10-28 11:34:29Z peterit $
 */

public class PersistedValueData extends AbstractValueData {
  
  /**
   * Create PersistedValueData with in-memory buffer option
   */
  public PersistedValueData(InputStream stream, int orderNumber, boolean inBuffer) throws IOException {
    super(stream, orderNumber, inBuffer);
  }
  
  /**
   * Create PersistedValueData with swap option
   */
  public PersistedValueData(InputStream stream, int orderNumber, BinaryValueSwapStorage swapStorage) throws IOException {
    super(stream, orderNumber, swapStorage);
  }
  
  /**
   * Create PersistedValueData with cloneable input stream option
   */
  public PersistedValueData(CloneableInputStream stream, int orderNumber) throws IOException {
    super(stream, orderNumber, false);
  }

}
