/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav;

import java.util.HashMap;
import org.apache.commons.logging.Log;
import org.exoplatform.services.jcr.util.UUIDGenerator;
import org.exoplatform.services.log.ExoLogger;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class FakeLockTable {

  private static Log log = ExoLogger.getLogger("jcr.FakeLockTable");
  
  protected HashMap<String, String> lockTable;
  
  public FakeLockTable() {
    lockTable = new HashMap<String, String>();
  }
  
  public String lockResource(String resPath) {
    if (lockTable.get(resPath) != null) {
      return null;
    }
    
    String newLockToken = UUIDGenerator.generate();
    
    log.info("GENERATED LOCK TOKEN - " + newLockToken);

    lockTable.put(resPath, newLockToken);
    
    return newLockToken;
  }
  
  public String getLockToken(String resPath) {
    return lockTable.get(resPath);
  }
  
  public void unLockResource(String resPath) {
    lockTable.remove(resPath);
  }
  
}
