/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.commands;

import javax.jcr.Node;
import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class CheckOutCommand extends WebDavCommand {

  private static Log log = ExoLogger.getLogger("jcr.CheckOutCommand");
  
  protected boolean process() {
    try {
      Node srcNode = (Node)jcrSrcSession().getItem(davRequest().getSrcPath());
      srcNode.checkout();
      jcrSrcSession().save();
      
      davResponse().answerOk();
      return true;
    } catch (Exception exc) {
      log.info("Unhandled exception. " + exc.getMessage(), exc);
    }
    
    davResponse().answerPreconditionFailed();
    return false;
  }
  
}
