/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.commands;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.webdav.request.RequestDoc;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class CopyCommand extends WebDavCommand {
  
  private static Log log = ExoLogger.getLogger("jcr.CopyCommand");

  public CopyCommand() {
    super();
    needDestSession = true;
  }
  
  protected boolean process() {
    RequestDoc requestDoc = davRequest().getDocumentFromRequest();
    try {
      jcrDestSession().getWorkspace().copy(
          davRequest().getSrcWorkspace(), 
          davRequest().getSrcPath(),
          davRequest().getDestPath());
      davResponse().answerCreated();
      return true;
    } catch (Exception exc) {
      log.info("Unhandled exception. " + exc.getMessage(), exc);
    }
    davResponse().answerForbidden();
    return false;
  }  
  
}
