/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.commands;

import org.exoplatform.services.webdav.DavConst;
import org.exoplatform.services.webdav.response.DavFileInfo;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class HeadCommand extends WebDavCommand {

  protected boolean process() {
    DavFileInfo resInfo = getResourceHeader();
    if (resInfo == null) {
      davResponse().answerNotFound();
      return false;
    }
    
    davResponse().setResponseHeader(DavConst.Headers.LASTMODIFIED, resInfo.getLastModified());
    davResponse().setResponseHeader(DavConst.Headers.CONTENTTYPE, resInfo.getContentType());
    if (!resInfo.isCollection()) {
      davResponse().setResponseHeader(DavConst.Headers.CONTENTLENGTH, String.format("%s", resInfo.getContentLength()));
    }
    davResponse().answerOk();
    return true;    
  }  

}
