/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.commands;

import javax.jcr.Node;
import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class MkColCommand extends WebDavCommand {
  
  private static Log log = ExoLogger.getLogger("jcr.MkColCommand");

  protected boolean process() {
    try {
      String []pathes = davRequest().getSrcPath().split("/");
      
      Node srcNode = jcrSrcSession().getRootNode();
      for (int i = 0; i < pathes.length; i++) {
        if ("".equals(pathes[i])) {
          continue;
        }
        if (srcNode.hasNode(pathes[i])) {
          srcNode = srcNode.getNode(pathes[i]);
        } else {
          srcNode.addNode(pathes[i], davContext().getConfig().getDefFolderNodeType());
          srcNode.save();
          break;
        }
      }
      jcrSrcSession().save();
      davResponse().answerCreated();
      return true;      
    } catch (Exception exc) {
      log.info("Unhandled exception. " + exc.getMessage(), exc);
    }
    davResponse().answerForbidden();
    return false;
  }

}
