/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.commands;

import javax.jcr.Node;
import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class MoveCommand extends WebDavCommand {
  
  private static Log log = ExoLogger.getLogger("jcr.MoveCommand");

  public MoveCommand() {
    super();
    needDestSession = true;
  }
  
  protected boolean process() {    
    try {      
      if (davRequest().getSrcWorkspace().equals(davRequest().getDestWorkspace())) {
        jcrDestSession().move(davRequest().getSrcPath(), davRequest().getDestPath());
        jcrDestSession().save();
      } else {
        jcrDestSession().getWorkspace().copy(
            davRequest().getSrcWorkspace(), 
            davRequest().getSrcPath(),
            davRequest().getDestPath());
        Node srcNode = (Node)jcrSrcSession().getItem(davRequest().getSrcPath()); 
        srcNode.remove();
        jcrSrcSession().save();
      }
      davResponse().answerCreated();
      return true;
    } catch (Exception exc) {
      log.info("Unhandled exception. " + exc.getMessage(), exc);
    }
    davResponse().answerForbidden();    
    return false;
  }  
  
}
