/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.commands;

import java.util.ArrayList;
import org.exoplatform.services.webdav.DavConst;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class OptionsCommand extends WebDavCommand {
  
  public OptionsCommand() {
    super();
    needSrcSession = false;
  }

  protected boolean process() {
    String allowedCommands = "";
    
    ArrayList<String> availableCommands = davContext().getAvailableCommands();
    for (int i = 0; i < availableCommands.size(); i++) {
      String curCommand = availableCommands.get(i);
      allowedCommands += curCommand;
      if (i < (availableCommands.size() - 1)) {
        allowedCommands += ", ";
      }
    }
    
    davResponse().setHeader(DavConst.Headers.ALLOW, allowedCommands);
    davResponse().setHeader(DavConst.Headers.DAV, DavConst.DAV_VERSIONS);
    davResponse().setHeader(DavConst.Headers.MSAUTHORVIA, DavConst.DAV_MSAUTHORVIA);
    
    return true;    
  }  

}
