/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.commands;

import java.util.ArrayList;

import org.exoplatform.services.webdav.DavConst;
import org.exoplatform.services.webdav.props.PropManager;
import org.exoplatform.services.webdav.props.WebDavProperty;
import org.exoplatform.services.webdav.request.PropertyUpdateDoc;
import org.exoplatform.services.webdav.request.RequestDoc;
import org.exoplatform.services.webdav.response.DMultistatus;
import org.exoplatform.services.webdav.response.DResponse;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class PropPatchCommand extends WebDavCommand {

  protected boolean process() {
    RequestDoc requestDoc = davRequest().getDocumentFromRequest();
    
    ArrayList<DResponse> responses = new ArrayList<DResponse>();
    
    DResponse response = new DResponse();    
    ArrayList<String> needsToSet = ((PropertyUpdateDoc)requestDoc).getPropertiesToSet();
    for (int i = 0; i < needsToSet.size(); i++) {
      String curPropertyName = needsToSet.get(i);
      WebDavProperty curProp = PropManager.getPropertyByName(curPropertyName);
      curProp.setStatus(DavConst.HttpStatus.CONFLICT);
      response.AddProperty(curProp);
    }
    
    ArrayList<String> needsToRemove = ((PropertyUpdateDoc)requestDoc).getPropertiesToRemove();
    for (int i = 0; i < needsToRemove.size(); i++) {
      String curPropertyName = needsToRemove.get(i);
      WebDavProperty curProp = PropManager.getPropertyByName(curPropertyName);
      curProp.setStatus(DavConst.HttpStatus.CONFLICT);
      response.AddProperty(curProp);
    }
    
    responses.add(response);
    
    davResponse().setMultistatus(new DMultistatus(responses));
    return true;    
  }
  
}
