/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.commands;

import java.util.ArrayList;

import javax.jcr.Node;
import javax.jcr.version.Version;
import javax.jcr.version.VersionHistory;
import javax.jcr.version.VersionIterator;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.webdav.DavConst;
import org.exoplatform.services.webdav.request.RequestDoc;
import org.exoplatform.services.webdav.request.VersionTreeDoc;
import org.exoplatform.services.webdav.response.DMultistatus;
import org.exoplatform.services.webdav.response.DResponse;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class ReportCommand extends WebDavCommand {

  private static Log log = ExoLogger.getLogger("jcr.ReportCommand");
  
  protected boolean process() {
    RequestDoc requestDoc = davRequest().getDocumentFromRequest();
    
    try {      
      Node srcNode = (Node)jcrSrcSession().getItem(davRequest().getSrcPath());
      ArrayList<DResponse> responces = new ArrayList<DResponse>();
      
      VersionHistory history = srcNode.getVersionHistory();
      VersionIterator verIter = history.getAllVersions();
  
      String pathNormalized = davRequest().getServerPrefix() + "/" + davRequest().getSrcWorkspace() + davRequest().getSrcPath();
      if (pathNormalized.endsWith("/")) {
        pathNormalized = pathNormalized.substring(0, pathNormalized.length() - 1);
      }
  
      while (verIter.hasNext()) {
        Version curVersion = verIter.nextVersion();        
        if (!curVersion.getName().equals(DavConst.NodeTypes.JCR_ROOTVERSION)) {          
          responces.add(getResponseByNode(curVersion, pathNormalized, (VersionTreeDoc)requestDoc));
        }
      }
      
      davResponse().setMultistatus(new DMultistatus(responces));      
      return true;
    } catch (Exception exc) {
      log.info("Unhandled exception. " + exc.getMessage(), exc);
    }
    
    davResponse().answerNotFound();    
    return false;
  }
  
}
