/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.commands;

import javax.jcr.Node;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.webdav.DavConst;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class VersionControlCommand extends WebDavCommand {

  private static Log log = ExoLogger.getLogger("jcr.VersionControlCommand");
  
  protected boolean process() {
    try {
      Node resNode = (Node)jcrSrcSession().getItem(davRequest().getSrcPath());

      if (davContext().getConfig().isAutoMixLockable()) {
        if (!resNode.isNodeType(DavConst.NodeTypes.MIX_LOCKABLE)) {
          resNode.addMixin(DavConst.NodeTypes.MIX_LOCKABLE);
        }
      }
      
      if (!resNode.isNodeType(DavConst.NodeTypes.MIX_VERSIONABLE)) {
        resNode.addMixin(DavConst.NodeTypes.MIX_VERSIONABLE);
        jcrSrcSession().save();
      }      
      
      davResponse().answerOk();
      return true;
    } catch (Exception exc) {
      log.info("Unhandled exception. " + exc.getMessage(), exc);
    }
    
    davResponse().answerForbidden();
    return false;
  }
  
}
