/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.props;

import javax.jcr.Node;
import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.webdav.DavConst;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class CheckedOutProp extends CommonProp {

  private static Log log = ExoLogger.getLogger("jcr.CheckedOutProp");
  
  public CheckedOutProp() {
    super(DavConst.DavProperty.CHECKEDOUT);
  }

  @Override
  public boolean fillFromNode(Node node, String href) {
    try {
      if (!node.isNodeType(DavConst.NodeTypes.MIX_VERSIONABLE)) {
        return false;
      }
      if (!node.isCheckedOut()) {
        return false;
      }
      status = DavConst.HttpStatus.OK;
      return true;
    } catch (Exception exc) {
      log.info("Unhandled exception. " + exc.getMessage());
      exc.printStackTrace();
    }
    
    return false;
  }  
  
  @Override
  public void toXml(Document rootDoc, Element parentElement) {
    super.toXml(rootDoc, parentElement);
  }
  
}
