/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.props;

import javax.jcr.Node;
import javax.jcr.Property;
import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.webdav.DavConst;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class ContentLengthProp extends CommonProp {

  private static Log log = ExoLogger.getLogger("jcr.ContentLengthProp");
  protected int contentLength = 0;
  
  public ContentLengthProp() {
    super(DavConst.DavProperty.GETCONTENTLENGTH);
  }
  
  @Override
  public boolean fillFromNode(Node node, String href) {
    try {
      if (node.isNodeType(DavConst.NodeTypes.NT_VERSION)) {
        node = node.getNode(DavConst.NodeTypes.JCR_FROZENNODE);
      }
      if (!node.hasNode(DavConst.NodeTypes.JCR_CONTENT)) {
        return false;
      }
      Node dataNode = node.getNode(DavConst.NodeTypes.JCR_CONTENT);
      Property dataProperty = dataNode.getProperty(DavConst.NodeTypes.JCR_DATA);
      contentLength = dataProperty.getStream().available();
      status = DavConst.HttpStatus.OK;
      return true;
    } catch (Exception exc) {
      log.info("Can't get resource for node. " + exc.getMessage(), exc);
    }
    return false;
  }

  @Override
  public void toXml(Document rootDoc, Element parentElement) {
    super.toXml(rootDoc, parentElement);
    if (status != DavConst.HttpStatus.OK) {
      return;
    }
    propertyElement.setTextContent(String.format("%s", contentLength));
  }
  
}
