/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.props;

import javax.jcr.Node;
import org.exoplatform.services.webdav.DavConst;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class CreatorDisplayNameProp extends CommonProp {

  protected String creatorDisplayName = "";
  
  public CreatorDisplayNameProp() {
    super(DavConst.DavProperty.CREATORDISPLAYNAME);
  }
  
  @Override
  public boolean fillFromNode(Node node, String href) {
    creatorDisplayName = "*** gavrik-vetal@mail.ru ***";
    status = DavConst.HttpStatus.OK;
    return false;
  }  
  
  @Override
  public void toXml(Document rootDoc, Element parentElement) {
    super.toXml(rootDoc, parentElement);
    if (status != DavConst.HttpStatus.OK) {
      return;
    }
    propertyElement.setTextContent(creatorDisplayName);
  }
  
}
