/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.props;

import javax.jcr.Node;
import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.webdav.DavConst;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class DisplayNameProp extends CommonProp {

  private static Log log = ExoLogger.getLogger("jcr.DisplayNameProp");
  protected String displayName = "";
  
  public DisplayNameProp() {
    super(DavConst.DavProperty.DISPLAYNAME);
  }
  
  public void setDisplayName(String displayName) {
    this.displayName = displayName;
  }
  
  public String getDisplayName() {
    return displayName;
  }

  @Override
  public boolean fillFromNode(Node node, String href) {
    try {
      displayName = node.getName();
      status = DavConst.HttpStatus.OK;
      return true;
    } catch (Exception exc) {
      log.info("Can't get node name. " + exc.getMessage());
      exc.printStackTrace();
    }
    return false;
  }  
  
  @Override
  public void toXml(Document rootDoc, Element parentElement) {
    super.toXml(rootDoc, parentElement);
    if (status != DavConst.HttpStatus.OK) {
      return;
    }
    propertyElement.setTextContent(displayName);
  }
  
}
