/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.props;

import org.exoplatform.services.webdav.DavConst;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class PropManager {

  protected static String [][]availableProperties = {
    {DavConst.DavProperty.CHECKEDIN, CheckedInProp.class.getCanonicalName()},
    {DavConst.DavProperty.CHECKEDOUT, CheckedOutProp.class.getCanonicalName()},
    {DavConst.DavProperty.GETCONTENTLENGTH, ContentLengthProp.class.getCanonicalName()},
    {DavConst.DavProperty.GETCONTENTTYPE, ContentTypeProp.class.getCanonicalName()},
    {DavConst.DavProperty.GETLASTMODIFIED, LastModifiedProp.class.getCanonicalName()},
    {DavConst.DavProperty.CREATIONDATE, CreationDateProp.class.getCanonicalName()},
    {DavConst.DavProperty.CREATORDISPLAYNAME, CreatorDisplayNameProp.class.getCanonicalName()},
    {DavConst.DavProperty.DISPLAYNAME, DisplayNameProp.class.getCanonicalName()},
    {DavConst.DavProperty.LOCKDISCOVERY, LockDiscoveryProp.class.getCanonicalName()},    
//    {"", "org.exoplatform.services.webdav.props.QuotaAvailableBytesProp"},
//    {"", "org.exoplatform.services.webdav.props.QuotaUsedBytesProp"},    
//    {"", "org.exoplatform.services.webdav.props.RefTargetProp"},    
    {DavConst.DavProperty.RESOURCETYPE, ResourceTypeProp.class.getCanonicalName()},
    {DavConst.DavProperty.VERSIONHISTORY, VersionHistoryProp.class.getCanonicalName()},
    {DavConst.DavProperty.VERSIONNAME, VersionNameProp.class.getCanonicalName()},
    {DavConst.DavProperty.SUCCESSORSET, SuccessorSetProp.class.getCanonicalName()}
  };

  public static WebDavProperty getPropertyByName(String propertyName) {
    try {
      for (int i = 0; i < availableProperties.length; i++) {
        if (propertyName.equals(availableProperties[i][0])) {
          return (WebDavProperty)Class.forName(availableProperties[i][1]).newInstance();
        }
      }      
    } catch (Exception exc) {
      System.out.println(String.format("Property '%s' is not registered.", propertyName));
      exc.printStackTrace();
    }    
    return new CommonProp(propertyName); 
  }
  
}
