/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.props;

import javax.jcr.Node;
import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.webdav.DavConst;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class ResourceTypeProp extends CommonProp {

  private static Log log = ExoLogger.getLogger("jcr.ResourceTypeProp");
  protected String resourceType = DavConst.ResourceType.COLLECTION;
  
  public ResourceTypeProp() {
    super(DavConst.DavProperty.RESOURCETYPE);
  }

  public void setResourceType(String resourceType) {
    this.resourceType = resourceType;
  }
  
  public String getResourceType() {
    return resourceType;
  }
  
  @Override
  public boolean fillFromNode(Node node, String href) {
    try {
      if (node.isNodeType(DavConst.NodeTypes.NT_FILE)) {
        resourceType = DavConst.ResourceType.RESOURCE;
      }
      status = DavConst.HttpStatus.OK;
      return true;
    } catch (Exception exc) {
      log.info("Can't get resource type. " + exc.getMessage());
      exc.printStackTrace();
    }
    return false;
  }
  
  @Override
  public void toXml(Document rootDoc, Element parentElement) {
    super.toXml(rootDoc, parentElement);
    if (DavConst.HttpStatus.OK != status) {
      return;
    }
    if (DavConst.ResourceType.COLLECTION.equals(resourceType)) {
      Element collection = rootDoc.createElement(DavConst.DAV_PREFIX + DavConst.DavProperty.COLLECTION);
      propertyElement.appendChild(collection);
    }
  }
  
}
