/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.request;

import java.io.InputStream;
import javax.jcr.Session;
import org.exoplatform.services.webdav.WebDavSessionProvider;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public interface WebDavRequest {

  Session getSourceSession(WebDavSessionProvider sessionProvider);
  
  Session getDestinationSession(WebDavSessionProvider sessionProvider);
    
  boolean isSameHosts();
  
  String getServerPrefix();
  
  String getServerApp();
  
  String getSrcWorkspace();
  
  String getSrcPath();
  
  String getSrcVersion();
  
  String getDestWorkspace();
  
  String getDestPath();
  
  String getLockToken();
  
  RequestDoc getDocumentFromRequest();
  
  InputStream getRequestStream() throws Exception;
  
  String getContentType();
  
}
