/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.response;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.exoplatform.services.webdav.DavConst;
import org.exoplatform.services.webdav.DavUtil;
import org.exoplatform.services.webdav.props.WebDavProperty;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: $
 */

public class DResponse {
  
  public DResponse() {
  }
  
  private String href = "";
  private ArrayList<WebDavProperty> propertyes = new ArrayList<WebDavProperty>();
    
  public void setHref(String href) {
    this.href = href;
  }
  
  public String getHref() {
    return href;
  }
  
  public void AddProperty(WebDavProperty property) {
    propertyes.add(property);
  }
  
  public void toXml(Document rootDoc, Element multistatusElement) {
    Element response = rootDoc.createElement(DavConst.DAV_PREFIX + DavConst.DavProperty.RESPONSE);
    multistatusElement.appendChild(response);
    
    Element hrefElement = rootDoc.createElement(DavConst.DAV_PREFIX + DavConst.DavProperty.HREF);
    response.appendChild(hrefElement);
    hrefElement.setTextContent(href);
    
    HashMap<Integer, ArrayList<WebDavProperty>> propStatusGroups = new HashMap<Integer, ArrayList<WebDavProperty>>();
    
    for (WebDavProperty curProp : propertyes) {
      int curPropStat = curProp.getStatus();
      ArrayList<WebDavProperty> propGroup = (ArrayList<WebDavProperty>)propStatusGroups.get(curPropStat);
      if (propGroup == null) {
        propGroup = new ArrayList<WebDavProperty>();
        propStatusGroups.put(new Integer(curPropStat), propGroup);
      }
      propGroup.add(curProp);
    }

    Iterator<Integer> groupStatusIter = propStatusGroups.keySet().iterator();
    while (groupStatusIter.hasNext()) {
      Integer curStatus = groupStatusIter.next();
      
      Element propStat = rootDoc.createElement(DavConst.DAV_PREFIX + DavConst.DavProperty.PROPSTAT);
      response.appendChild(propStat);
      
      Element prop = rootDoc.createElement(DavConst.DAV_PREFIX + DavConst.DavProperty.PROP);
      propStat.appendChild(prop);
      
      ArrayList<WebDavProperty> propList = propStatusGroups.get(curStatus);
      for (int i = 0; i < propList.size(); i++) {
        WebDavProperty curProp = propList.get(i);
        curProp.toXml(rootDoc, prop);
      }
      
      Element status = rootDoc.createElement(DavConst.DAV_PREFIX + DavConst.DavProperty.STATUS);
      propStat.appendChild(status);
      status.setTextContent(DavUtil.GetStatusInfo(curStatus));
    }
    
  }
  
}
